diff --git a/drupal7/sites/all/modules/rules/includes/rules.core.inc b/drupal7/sites/all/modules/rules/includes/rules.core.inc
index 24d85c63..5dbc332d 100644
--- a/drupal7/sites/all/modules/rules/includes/rules.core.inc
+++ b/drupal7/sites/all/modules/rules/includes/rules.core.inc
@@ -1622,7 +1622,7 @@ abstract class RulesAbstractPlugin extends RulesPlugin {
   public function dependencies() {
     $modules = array_flip(parent::dependencies());
     $modules += array_flip((array) $this->__call('dependencies'));
-    return array_keys($modules + (isset($this->info['module']) ? array($this->info['module'] => 1) : array()));
+    return array_keys($modules + (!empty($this->info['module']) ? array($this->info['module'] => 1) : array()));
   }
 
   public function executeByArgs($args = array()) {
diff --git a/drupal7/sites/all/modules/rules/modules/data.eval.inc b/drupal7/sites/all/modules/rules/modules/data.eval.inc
index 6b9a95af..9fbbb7a0 100644
--- a/drupal7/sites/all/modules/rules/modules/data.eval.inc
+++ b/drupal7/sites/all/modules/rules/modules/data.eval.inc
@@ -294,6 +294,7 @@ function rules_action_data_create_info_alter(&$element_info, RulesAbstractPlugin
         $element_info['parameter']['param_' . $property] = array_intersect_key($property_info, array_flip(array('type', 'label', 'allow null')));
         if (empty($property_info['required'])) {
           $element_info['parameter']['param_' . $property]['optional'] = TRUE;
+          $element_info['parameter']['param_' . $property]['allow null'] = TRUE;
         }
       }
     }
@@ -366,6 +367,20 @@ function rules_condition_data_list_contains($list, $item, $settings, $state) {
   return in_array($item, $list);
 }
 
+/**
+* Condition: List count comparison.
+*/
+function rules_condition_data_list_count_is($list, $op = '==', $value) {
+  switch ($op) {
+    case '==':
+      return count($list) == $value;
+    case '<';
+      return count($list) < $value;
+    case '>';
+      return count($list) > $value;
+  }
+}
+
 /**
  * Condition: Data value is empty.
  */
diff --git a/drupal7/sites/all/modules/rules/modules/data.rules.inc b/drupal7/sites/all/modules/rules/modules/data.rules.inc
index 412586f9..96caae23 100644
--- a/drupal7/sites/all/modules/rules/modules/data.rules.inc
+++ b/drupal7/sites/all/modules/rules/modules/data.rules.inc
@@ -555,6 +555,32 @@ function rules_data_condition_info() {
         'form_alter' => 'rules_data_list_form_alter',
       ),
     ),
+    'list_count_is' => array(
+      'label' => t('List count comparison'),
+      'parameter' => array(
+        'list' => array(
+          'type' => 'list',
+          'label' => t('List to check'),
+          'description' => t('A multi value data element to have its count compared, specified by using a data selector, eg node:author:roles.'),
+        ),
+        'op' => array(
+          'type' => 'text',
+          'label' => t('Operator'),
+          'description' => t('The comparison operator.'),
+          'optional' => TRUE,
+          'default value' => '==',
+          'options list' => 'rules_condition_data_list_count_is_operator_options',
+          'restriction' => 'input',
+        ),
+        'value' => array(
+          'type' => 'integer',
+          'label' => t('Count'),
+          'description' => t('The count to compare the data count with.'),
+        ),
+      ),
+      'group' => t('Data'),
+      'base' => 'rules_condition_data_list_count_is',
+    ),
     'text_matches'  => array(
       'label' => t('Text comparison'),
       'parameter' => array(
@@ -719,6 +745,17 @@ function rules_data_selector_options_list(RulesAbstractPlugin $element) {
   }
 }
 
+/**
+ * Options list callback for condition list_count_is.
+ */
+function rules_condition_data_list_count_is_operator_options() {
+  return array(
+    '==' => t('equals'),
+    '<' => t('is lower than'),
+    '>' => t('is greater than'),
+  );
+}
+
 /**
  * @}
  */
diff --git a/drupal7/sites/all/modules/rules/modules/rules_core.rules.inc b/drupal7/sites/all/modules/rules/modules/rules_core.rules.inc
index 39fff93e..d4215fa2 100644
--- a/drupal7/sites/all/modules/rules/modules/rules_core.rules.inc
+++ b/drupal7/sites/all/modules/rules/modules/rules_core.rules.inc
@@ -120,6 +120,12 @@ function rules_rules_core_data_info() {
       'group' => t('Entity'),
       'is wrapped' => TRUE,
     ),
+    'ip_address' => array(
+      'label' => t('IP Address'),
+      'parent' => 'text',
+      'ui class' => 'RulesDataUIIPAddress',
+      'token type' => 'rules_text',
+    ),
   );
   foreach (entity_get_info() as $type => $info) {
     if (!empty($info['label'])) {
diff --git a/drupal7/sites/all/modules/rules/modules/system.eval.inc b/drupal7/sites/all/modules/rules/modules/system.eval.inc
index a27225f9..0de887c1 100644
--- a/drupal7/sites/all/modules/rules/modules/system.eval.inc
+++ b/drupal7/sites/all/modules/rules/modules/system.eval.inc
@@ -150,6 +150,17 @@ function rules_mail($key, &$message, $params) {
   $message['body'][] = $params['message'];
 }
 
+/**
+ * Action: Block an IP address.
+ */
+function rules_action_block_ip($ip_address = NULL) {
+  if (empty($ip_address)) {
+    $ip_address = ip_address();
+  }
+  db_insert('blocked_ips')->fields(array('ip' => $ip_address))->execute();
+  watchdog('rules', 'Banned IP address %ip', array('%ip' => $ip_address));
+}
+
 /**
  * A class implementing a rules input evaluator processing tokens.
  */
diff --git a/drupal7/sites/all/modules/rules/modules/system.rules.inc b/drupal7/sites/all/modules/rules/modules/system.rules.inc
index fcd4f808..2df01a3a 100644
--- a/drupal7/sites/all/modules/rules/modules/system.rules.inc
+++ b/drupal7/sites/all/modules/rules/modules/system.rules.inc
@@ -242,6 +242,21 @@ function rules_system_action_info() {
       'base' => 'rules_action_mail_to_users_of_role',
       'access callback' => 'rules_system_integration_access',
     ),
+    'block_ip' => array(
+      'label' => t('Block IP address'),
+      'group' => t('System'),
+      'parameter' => array(
+        'ip_address' => array(
+          'type' => 'ip_address',
+          'label' => t('IP address'),
+          'description' => t('If not provided, the IP address of the current user will be used.'),
+          'optional' => TRUE,
+          'default value' => NULL,
+        ),
+      ),
+      'base' => 'rules_action_block_ip',
+      'access callback' => 'rules_system_integration_access',
+    ),
   );
 }
 
diff --git a/drupal7/sites/all/modules/rules/modules/user.eval.inc b/drupal7/sites/all/modules/rules/modules/user.eval.inc
index d7bb8231..a990bfb9 100644
--- a/drupal7/sites/all/modules/rules/modules/user.eval.inc
+++ b/drupal7/sites/all/modules/rules/modules/user.eval.inc
@@ -103,6 +103,7 @@ function rules_action_user_unblock($account) {
 function rules_action_user_send_account_email($account, $email_type) {
   // If we received an authenticated user account...
   if (!empty($account->uid)) {
+    module_load_include('inc', 'rules', 'modules/user.rules');
     $types = rules_user_account_email_options_list();
 
     // Attempt to send the account e-mail.
diff --git a/drupal7/sites/all/modules/rules/rules.info b/drupal7/sites/all/modules/rules/rules.info
index adb9856f..84d21d4f 100644
--- a/drupal7/sites/all/modules/rules/rules.info
+++ b/drupal7/sites/all/modules/rules/rules.info
@@ -22,9 +22,9 @@ files[] = ui/ui.plugins.inc
 dependencies[] = entity_token
 dependencies[] = entity
 
-; Information added by drupal.org packaging script on 2013-10-29
-version = "7.x-2.6"
+; Information added by Drupal.org packaging script on 2014-05-02
+version = "7.x-2.7"
 core = "7.x"
 project = "rules"
-datestamp = "1383063052"
+datestamp = "1399041230"
 
diff --git a/drupal7/sites/all/modules/rules/rules.module b/drupal7/sites/all/modules/rules/rules.module
index d2ff900c..84900f2d 100644
--- a/drupal7/sites/all/modules/rules/rules.module
+++ b/drupal7/sites/all/modules/rules/rules.module
@@ -4,11 +4,14 @@
  * @file Rules engine module
  */
 
+// Include our hook implementations early, as they can be called even before
+// hook_init().
+require_once dirname(__FILE__) . '/modules/events.inc';
+
 /**
  * Implements hook_init().
  */
 function rules_init() {
-  module_load_include('inc', 'rules', 'modules/events');
   rules_invoke_event('init');
 }
 
diff --git a/drupal7/sites/all/modules/rules/rules.rules.inc b/drupal7/sites/all/modules/rules/rules.rules.inc
index fcd3c94c..3beb76eb 100644
--- a/drupal7/sites/all/modules/rules/rules.rules.inc
+++ b/drupal7/sites/all/modules/rules/rules.rules.inc
@@ -10,7 +10,6 @@
  */
 foreach (rules_core_modules() as $module) {
   module_load_include('inc', 'rules', "modules/$module.rules");
-  module_load_include('inc', 'rules', 'modules/events');
 }
 
 /**
diff --git a/drupal7/sites/all/modules/rules/rules_admin/rules_admin.info b/drupal7/sites/all/modules/rules/rules_admin/rules_admin.info
index d8d731b6..c2382e02 100644
--- a/drupal7/sites/all/modules/rules/rules_admin/rules_admin.info
+++ b/drupal7/sites/all/modules/rules/rules_admin/rules_admin.info
@@ -6,9 +6,9 @@ files[] = rules_admin.module
 files[] = rules_admin.inc
 dependencies[] = rules
 
-; Information added by drupal.org packaging script on 2013-10-29
-version = "7.x-2.6"
+; Information added by Drupal.org packaging script on 2014-05-02
+version = "7.x-2.7"
 core = "7.x"
 project = "rules"
-datestamp = "1383063052"
+datestamp = "1399041230"
 
diff --git a/drupal7/sites/all/modules/rules/rules_i18n/rules_i18n.info b/drupal7/sites/all/modules/rules/rules_i18n/rules_i18n.info
index 6e006fc7..4a311312 100644
--- a/drupal7/sites/all/modules/rules/rules_i18n/rules_i18n.info
+++ b/drupal7/sites/all/modules/rules/rules_i18n/rules_i18n.info
@@ -7,9 +7,9 @@ core = 7.x
 files[] = rules_i18n.i18n.inc
 files[] = rules_i18n.rules.inc
 files[] = rules_i18n.test
-; Information added by drupal.org packaging script on 2013-10-29
-version = "7.x-2.6"
+; Information added by Drupal.org packaging script on 2014-05-02
+version = "7.x-2.7"
 core = "7.x"
 project = "rules"
-datestamp = "1383063052"
+datestamp = "1399041230"
 
diff --git a/drupal7/sites/all/modules/rules/rules_scheduler/includes/rules_scheduler.views_default.inc b/drupal7/sites/all/modules/rules/rules_scheduler/includes/rules_scheduler.views_default.inc
index cdb06fb9..de345f2f 100644
--- a/drupal7/sites/all/modules/rules/rules_scheduler/includes/rules_scheduler.views_default.inc
+++ b/drupal7/sites/all/modules/rules/rules_scheduler/includes/rules_scheduler.views_default.inc
@@ -86,7 +86,7 @@ function rules_scheduler_views_default_views() {
   $handler->display->display_options['fields']['config']['field'] = 'config';
   $handler->display->display_options['fields']['config']['alter']['alter_text'] = 0;
   $handler->display->display_options['fields']['config']['alter']['make_link'] = 1;
-  $handler->display->display_options['fields']['config']['alter']['path'] = 'admin/config/workflow/rules/config/[config]';
+  $handler->display->display_options['fields']['config']['alter']['path'] = 'admin/config/workflow/rules/components/manage/[config]';
   $handler->display->display_options['fields']['config']['alter']['absolute'] = 0;
   $handler->display->display_options['fields']['config']['alter']['trim'] = 0;
   $handler->display->display_options['fields']['config']['alter']['word_boundary'] = 1;
@@ -163,7 +163,7 @@ function rules_scheduler_views_default_views() {
     t('No tasks have been scheduled.'),
     t('Tid'),
     t('Component name'),
-    t('admin/config/workflow/rules/config/[config]'),
+    t('admin/config/workflow/rules/components/manage/[config]'),
     t('Scheduled date'),
     t('User provided identifier'),
     t('Operations'),
diff --git a/drupal7/sites/all/modules/rules/rules_scheduler/rules_scheduler.info b/drupal7/sites/all/modules/rules/rules_scheduler/rules_scheduler.info
index 65463e74..5b66f537 100644
--- a/drupal7/sites/all/modules/rules/rules_scheduler/rules_scheduler.info
+++ b/drupal7/sites/all/modules/rules/rules_scheduler/rules_scheduler.info
@@ -13,9 +13,9 @@ files[] = includes/rules_scheduler.views_default.inc
 files[] = includes/rules_scheduler.views.inc
 files[] = includes/rules_scheduler_views_filter.inc
 
-; Information added by drupal.org packaging script on 2013-10-29
-version = "7.x-2.6"
+; Information added by Drupal.org packaging script on 2014-05-02
+version = "7.x-2.7"
 core = "7.x"
 project = "rules"
-datestamp = "1383063052"
+datestamp = "1399041230"
 
diff --git a/drupal7/sites/all/modules/rules/rules_scheduler/rules_scheduler.install b/drupal7/sites/all/modules/rules/rules_scheduler/rules_scheduler.install
index 982dcf77..202c861a 100644
--- a/drupal7/sites/all/modules/rules/rules_scheduler/rules_scheduler.install
+++ b/drupal7/sites/all/modules/rules/rules_scheduler/rules_scheduler.install
@@ -144,12 +144,14 @@ function rules_scheduler_update_7203() {
  * Rename rules_scheduler.state into rules_scheduler.data.
  */
 function rules_scheduler_update_7204() {
-  db_change_field('rules_scheduler', 'state', 'data', array(
-    'type' => 'text',
-    'not null' => FALSE,
-    'serialize' => TRUE,
-    'description' => 'The whole, serialized evaluation data.',
-  ));
+  if (db_field_exists('rules_scheduler', 'state')) {
+    db_change_field('rules_scheduler', 'state', 'data', array(
+      'type' => 'text',
+      'not null' => FALSE,
+      'serialize' => TRUE,
+      'description' => 'The whole, serialized evaluation data.',
+    ));
+  }
 }
 
 /**
diff --git a/drupal7/sites/all/modules/rules/rules_scheduler/rules_scheduler.module b/drupal7/sites/all/modules/rules/rules_scheduler/rules_scheduler.module
index d3350322..b74973d5 100644
--- a/drupal7/sites/all/modules/rules/rules_scheduler/rules_scheduler.module
+++ b/drupal7/sites/all/modules/rules/rules_scheduler/rules_scheduler.module
@@ -40,6 +40,11 @@ function rules_scheduler_cron_queue_info() {
  */
 function rules_scheduler_run_task(array $task) {
   try {
+    // BC support for tasks that have been already queued, before update
+    // rules_scheduler_update_7204() ran.
+    if (isset($task['state'])) {
+      $task['data'] = $task['state'];
+    }
     rules_scheduler_task_handler($task)->runTask();
   }
   catch (RulesEvaluationException $e) {
@@ -189,10 +194,13 @@ function rules_scheduler_queue_tasks() {
  * Implements hook_rules_config_delete().
  */
 function rules_scheduler_rules_config_delete($rules_config) {
-  // Delete all tasks scheduled for this config.
-  db_delete('rules_scheduler')
-    ->condition('config', $rules_config->name)
-    ->execute();
+  // Only react on real delete, not revert.
+  if (!$rules_config->hasStatus(ENTITY_IN_CODE)) {
+    // Delete all tasks scheduled for this config.
+    db_delete('rules_scheduler')
+      ->condition('config', $rules_config->name)
+      ->execute();
+  }
 }
 
 /**
diff --git a/drupal7/sites/all/modules/rules/rules_scheduler/tests/rules_scheduler_test.info b/drupal7/sites/all/modules/rules/rules_scheduler/tests/rules_scheduler_test.info
index a9fc9d32..df1405b2 100644
--- a/drupal7/sites/all/modules/rules/rules_scheduler/tests/rules_scheduler_test.info
+++ b/drupal7/sites/all/modules/rules/rules_scheduler/tests/rules_scheduler_test.info
@@ -5,9 +5,9 @@ core = 7.x
 files[] = rules_scheduler_test.inc
 hidden = TRUE
 
-; Information added by drupal.org packaging script on 2013-10-29
-version = "7.x-2.6"
+; Information added by Drupal.org packaging script on 2014-05-02
+version = "7.x-2.7"
 core = "7.x"
 project = "rules"
-datestamp = "1383063052"
+datestamp = "1399041230"
 
diff --git a/drupal7/sites/all/modules/rules/tests/rules_test.info b/drupal7/sites/all/modules/rules/tests/rules_test.info
index 42373b4d..c87a8f96 100644
--- a/drupal7/sites/all/modules/rules/tests/rules_test.info
+++ b/drupal7/sites/all/modules/rules/tests/rules_test.info
@@ -6,9 +6,9 @@ files[] = rules_test.rules.inc
 files[] = rules_test.rules_defaults.inc
 hidden = TRUE
 
-; Information added by drupal.org packaging script on 2013-10-29
-version = "7.x-2.6"
+; Information added by Drupal.org packaging script on 2014-05-02
+version = "7.x-2.7"
 core = "7.x"
 project = "rules"
-datestamp = "1383063052"
+datestamp = "1399041230"
 
diff --git a/drupal7/sites/all/modules/rules/ui/ui.data.inc b/drupal7/sites/all/modules/rules/ui/ui.data.inc
index 8ee91f01..f99486b3 100644
--- a/drupal7/sites/all/modules/rules/ui/ui.data.inc
+++ b/drupal7/sites/all/modules/rules/ui/ui.data.inc
@@ -300,6 +300,23 @@ class RulesDataUIInteger extends RulesDataUIText {
   }
 }
 
+/**
+ * UI for IP addresses.
+ */
+class RulesDataUIIPAddress extends RulesDataUIText {
+
+  public static function inputForm($name, $info, $settings, RulesPlugin $element) {
+    $form = parent::inputForm($name, $info, $settings, $element);
+    if (empty($info['options list'])) {
+      $form[$name]['#type'] = 'textfield';
+      $form[$name]['#description'] = t('If not provided, the IP address of the current user will be used.');
+    }
+    $form[$name]['#element_validate'][] = 'rules_ui_element_ip_address_validate';
+    $form[$name]['#rows'] = 1;
+    return $form;
+  }
+}
+
 /**
  * UI for boolean data.
  */
diff --git a/drupal7/sites/all/modules/rules/ui/ui.forms.inc b/drupal7/sites/all/modules/rules/ui/ui.forms.inc
index b81fb39e..b01e0f53 100644
--- a/drupal7/sites/all/modules/rules/ui/ui.forms.inc
+++ b/drupal7/sites/all/modules/rules/ui/ui.forms.inc
@@ -684,6 +684,16 @@ function rules_ui_element_decimal_validate($element, &$form_state) {
   }
 }
 
+/**
+ * FAPI callback to validate an IP address.
+ */
+function rules_ui_element_ip_address_validate($element, &$form_state) {
+  $value = $element['#value'];
+  if ($value != '' && !filter_var($value, FILTER_VALIDATE_IP)) {
+    form_error($element, t('%name is not a valid IP address.', array('%name' => $element['#title'])));
+  }
+}
+
 /**
  * FAPI validation of a date element. Makes sure the specified date format is
  * correct and converts date values specifiy a fixed (= non relative) date to
